package com.tienda.dao;

public abstract class DAOFactory {

  private static DAOFactory instance;

  private static final String daoFactoryClassName = "com.garage.dao.hibernate.HibernateDAOFactory";

  public static DAOFactory getInstance() {
    if(instance == null) {
      try {
        instance = (DAOFactory) Class.forName(daoFactoryClassName).newInstance();
      } catch (Exception e) {
        throw new RuntimeException("Could not instantiate DAO factory class ["+daoFactoryClassName+"]", e);
      }
    }
    return instance;
  }

  public abstract UsuarioDAO getUsuarioDAO();
  public abstract PedidoDAO getPedidoDAO();


}