package com.tienda.struts.action;

import org.apache.struts.action.RequestProcessor;
import javax.servlet.ServletException;
import javax.servlet.http.*;
import org.apache.struts.action.*;

import com.tienda.Usuario;

import java.io.IOException;



public class SecurityRequestProcessor extends RequestProcessor
{
	private static final String loginPath = "/login";

	protected boolean processRoles(HttpServletRequest request,
			HttpServletResponse response,ActionMapping mapping)
			throws IOException,ServletException
	{
		// Est esta accin protegida por roles?
        String roles[] = mapping.getRoleNames();
        if ((roles == null) || (roles.length < 1))
        {
            return true;
        }

        // Comprueba si el usuario que hay en la session tiene dicho rol
        HttpSession ses = request.getSession();
		Usuario u = (Usuario)ses.getAttribute("usuario");
        if (u == null)
        {
            return false;
        }
        for (int i = 0; i < roles.length; i++)
        {
            if (u.getRole().equals(roles[i]))
            {
                return true;
            }
        }
        response.sendError(HttpServletResponse.SC_BAD_REQUEST, getInternal()
                .getMessage("notAuthorized", mapping.getPath()));
        return false;
	}

	protected boolean processPreprocess(HttpServletRequest request,
			HttpServletResponse response)
	{
		String requestPath = null;
        String forwardPath = null;
        ActionMapping loginActionMapping = null;

        HttpSession ses = request.getSession();
		if(ses.getAttribute("usuario")!=null)
		{

			return true;
		}
		try {
            requestPath = processPath(request,response);
	    }
	    catch( IOException e ) {
	        return true;
	    }
	    if(requestPath.equals(loginPath))
	    	return true;

	    ses.setAttribute( "originalRequest", requestPath );

	    try {
	    	loginActionMapping = processMapping( request, response,loginPath);
	    	forwardPath = loginActionMapping.getInputForward().getPath();
	    	doForward(forwardPath,request,response);
	    	return false;
	    }
	    catch( Exception e ) {
	        return true;
	    }
	}
}
